using UnityEngine;

namespace Damage
{
    public class HealthGunOrganBehaviour : EffectGunBehaviour
    {
        protected override void Affect(Collider2D coll)
        {
            LimbBehaviour limb;
            if (!this.TryGetLimb(coll, out limb) || limb.IsAndroid)
                return;
            limb.HealBone();
            limb.Health = limb.InitialHealth;
            limb.CirculationBehaviour.HealBleeding();
            limb.SkinMaterialHandler.AcidProgress *= 0.25f;
            limb.SkinMaterialHandler.RottenProgress = 0.0f;
            limb.PhysicalBehaviour.BurnProgress *= 0.8f;
            limb.Numbness *= 0.0f;
            limb.CirculationBehaviour.IsPump = limb.CirculationBehaviour.WasInitiallyPumping;
            limb.CirculationBehaviour.BloodFlow = 5f;
            double num = (double) limb.CirculationBehaviour.AddLiquid(limb.GetOriginalBloodType(), 5f);
            limb.Frozen = false;
            
            HumanDamageBehaviour damage = limb.gameObject.GetComponent<HumanDamageBehaviour>();
            if (damage)
            {
                damage.HealBone();
                damage.tissueHealth = damage.tissueInitialHealth;
                foreach (Organ organ in damage.organs)
                {
                    damage.RepairOrgan(organ);
                }
            }

            if (limb.RoughClassification != LimbBehaviour.BodyPart.Head)
                return;
            limb.Person.ShockLevel = 0.0f;
            limb.Person.PainLevel = 0.0f;
            limb.Person.AdrenalineLevel = 1f;
            limb.Person.Consciousness += 0.5f;
        }
    }
}