using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Damage
{
    public class Mod
    {
        public static bool spawnerEnabled = true;
        public static PhysicalProperties humanProperties;

        public static void Main()
        {
            ModAPI.RegisterLiquid(UltraStrengthOrganSyringe.UltraStrengthOrganSerumLiquid.ID, new UltraStrengthOrganSyringe.UltraStrengthOrganSerumLiquid());
            ModAPI.Register<SpawnBehaviour>();

            ModAPI.OnItemSpawned += (sender, obj) =>
            {
                GameObject gameObj = obj.Instance;
                PersonBehaviour person = gameObj.GetComponent<PersonBehaviour>();
                LimbBehaviour limb = gameObj.GetComponent<LimbBehaviour>();
                if (spawnerEnabled)
                {
                    if (person)
                    {
                        foreach (LimbBehaviour limbBehaviour in person.Limbs)
                        {
                            if (!limbBehaviour.gameObject.GetComponent<HumanDamageBehaviour>() && limbBehaviour.SpeciesIdentity == "Human")
                                limbBehaviour.gameObject.AddComponent<HumanDamageBehaviour>();
                            if (!limbBehaviour.PhysicalBehaviour.Properties != humanProperties && limbBehaviour.SpeciesIdentity == "Human")
                                limbBehaviour.PhysicalBehaviour.Properties = humanProperties;
                        }
                    }
                    if (gameObj.TryGetComponent<HealthGunBehaviour>(out HealthGunBehaviour health))
                    {
                        HealthGunOrganBehaviour gun = obj.Instance.AddComponent<HealthGunOrganBehaviour>();
                        gun.range = health.range;
                        gun.offset = health.offset;
                        gun.PhysicalBehaviour = health.PhysicalBehaviour;
                        gun.ShotSounds = health.ShotSounds;
                        gun.Muzzleflash = health.Muzzleflash;
                        gun.barrelPosition = health.barrelPosition;
                        gun.barrelDirection = health.barrelDirection;
                        UnityEngine.Object.Destroy(health);
                    }
                    if (gameObj.TryGetComponent<UltraStrengthSyringe>(out UltraStrengthSyringe strength))
                    {
                        UltraStrengthOrganSyringe syringe = obj.Instance.AddComponent<UltraStrengthOrganSyringe>();
                        UnityEngine.Object.Destroy(strength);
                    }
                }
            };
        }
    }
}