using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Damage
{
    public class SpawnBehaviour : MonoBehaviour
    {
        public bool spawnerEnabled = true;
        int i;
        
        void Start()
        {
            ModAPI.Notify("Advanced Damage added! Double press M to enable or disable applying the script to spawned humans.");
            StartCoroutine("DoublePress");

            PhysicalProperties prop = ScriptableObject.CreateInstance<PhysicalProperties>();
            PhysicalProperties human = ModAPI.FindPhysicalProperties("Human");

            prop.SharpForceThresholdMultiplier = human.SharpForceThresholdMultiplier;
            prop.LodgeStrengthMultiplier = human.LodgeStrengthMultiplier;
            prop.BurningTemperatureThreshold = human.BurningTemperatureThreshold;
            prop.HeatTransferSpeedMultiplier = human.HeatTransferSpeedMultiplier;
            prop.ImpactIntensityMutliplier = human.ImpactIntensityMutliplier;
            prop.HitVolumeMultiplier = human.HitVolumeMultiplier;
            prop.PhysicMaterial = human.PhysicMaterial;
            prop.Sharp = human.Sharp;
            prop.SharpAxes = human.SharpAxes;
            prop.Softness = human.Softness;
            prop.Brittleness = human.Brittleness;
            prop.Buoyancy = human.Buoyancy;
            prop.Flammability = human.Flammability;
            prop.MagneticAttractionIntensity = human.MagneticAttractionIntensity;
            prop.Conducting = human.Conducting;
            prop.Burnrate = human.Burnrate;
            prop.SizzleSounds = human.SizzleSounds;
            prop.SoftImpact = human.SoftImpact;
            prop.HardImpact = human.HardImpact;
            prop.SlidingLoop = human.SlidingLoop;
            prop.StabSound = human.StabSound;
            prop.ShotImpact = human.ShotImpact;

            prop.BulletSpeedAbsorptionPower = 2f;

            Mod.humanProperties = prop;
        }
        void Update()
        {
            if (Input.GetKeyDown(KeyCode.M))
            {
                i++;
                if (i >= 2)
                {
                    if (Mod.spawnerEnabled)
                    {
                        ModAPI.Notify("Automatic applying disabled!");
                        Mod.spawnerEnabled = false;
                    }
                    else
                    {
                        ModAPI.Notify("Automatic applying enabled!");
                        Mod.spawnerEnabled = true;
                    }
                    i = 0;
                }
            }
        }
        private IEnumerator DoublePress()
        {
            while(1 == 1)
            {
                i = 0;
                yield return new WaitForSeconds(1f);
            }
        }
    }
}